////////////////////////////////////////////////////////////////////////
// channels_widget.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.channels_widget")

// <%pre>
#line 1 "channels_widget.ecpp"

#include <vdr/channels.h>
#include "exception.h"
#include "setup.h"
#include "tools.h"

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("channels_widget");

static const char* rawData = "\000\000\000,\000\000\000-\000\000\000;\000\000\000A\000\000\000C\000\000\000E\000\000"
  "\000V\000\000\000\134\000\000\000]\000\000\000g\000\000\000q\n<select name=\"\" id=\"\" >\n\t\t<option value=\"\" \n"
  "\t\t\t></option>\n</select>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("channels_widget " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string name = qparam.param("name", ( "channel"));
std::string selected = qparam.param("selected");
std::string onchange = qparam.param("onchange");
bool channelid = qparam.has("channelid") ? tnt::stringToWithDefault<bool>(qparam.param("channelid"), ( false), reply.out().getloc()) : ( false);
  // </%args>

#line 17 "channels_widget.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 19 "channels_widget.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << data[0]; // \n
#line 22 "channels_widget.ecpp"

	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );

  reply.out() << data[1]; // <select name="
#line 27 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << data[2]; // " id="
#line 27 "channels_widget.ecpp"
  reply.sout() << ( name );
  reply.out() << data[3]; // " 
#line 27 "channels_widget.ecpp"
 reply.out() << ( !onchange.empty() ? "onchange=\""+onchange+"\"" : "" ); 
  reply.out() << data[4]; // >\n
#line 28 "channels_widget.ecpp"
	for ( cChannel *listChannel = Channels.First(); listChannel; listChannel = Channels.Next( listChannel ) ) {

#line 29 "channels_widget.ecpp"
		if ( listChannel->GroupSep() || *listChannel->Name() == '\0' )

#line 30 "channels_widget.ecpp"
			continue;

#line 31 "channels_widget.ecpp"


#line 32 "channels_widget.ecpp"
		std::string listChannelId = *listChannel->GetChannelID().ToString();

  reply.out() << data[5]; // \t\t<option value="
#line 33 "channels_widget.ecpp"
  if ( channelid )
    reply.sout() <<  *listChannel->GetChannelID().ToString() ;
#line 33 "channels_widget.ecpp"
  if ( !channelid )
    reply.sout() <<  listChannel->Number() ;
  reply.out() << data[6]; // " \n\t\t\t
#line 34 "channels_widget.ecpp"
 reply.out() << ( listChannelId == selected ? "selected=\"selected\"" : "" ); 
  reply.out() << data[7]; // >
#line 34 "channels_widget.ecpp"
  reply.sout() << ( listChannel->Name() );
  reply.out() << data[8]; // </option>\n
#line 35 "channels_widget.ecpp"
	}

  reply.out() << data[9]; // </select>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
