////////////////////////////////////////////////////////////////////////
// ibox.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.ibox")

// <%pre>
#line 1 "ibox.ecpp"

#include <vdr/plugin.h>
#include <vdr/config.h>
#include <vdr/recording.h>
#include <vdr/channels.h>
#include <vdr/menu.h>
#include <vdr/device.h>

#include "exception.h"
#include "setup.h"
#include "tools.h"
#include "epg_events.h"
#include "recman.h"
#include "timerconflict.h"

using namespace vdrlive;
using namespace std;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("ibox");

static const char* rawData = "\000\000\000\030\000\000\000\031\000\000\000\032\000\000\000\033\000\000\000\034\000\000"
  "\000\035\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("ibox " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int update = tnt::stringTo<int>("update", "int", qparam.param("update"), reply.out().getloc());
  // </%args>

#line 24 "ibox.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 25 "ibox.ecpp"
  typedef int update_status_type;
  TNT_SESSION_GLOBAL_VAR(update_status_type, update_status, "int update_status", (1));   // <%session> int update_status(1)
#line 26 "ibox.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
  // <%cpp>
#line 28 "ibox.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	string EMPTY_STR;
	tChannelID prev_chan;
	tChannelID next_chan;
	reply.setContentType( "application/xml" );

	if (update_status != update) {
		update_status = update;
	}

	string infoMsg;
	string infoUrl;

	if (timerNotifier.ShouldNotify()) {
		infoMsg = timerNotifier.Message();
		infoUrl = "timerconflicts.html";
	}

	const char* NowReplaying = cReplayControl::NowReplaying();

	EpgInfoPtr epgEvent;

	if (NowReplaying) {
		RecordingsManagerPtr recManager = LiveRecordingsManager();
		cRecording *recording = Recordings.GetByName(NowReplaying);
		if (recording) {
			epgEvent = EpgEvents::CreateEpgInfo(recManager->Md5Hash(recording),
												recording,
												tr("playing recording"));
		}
	}
	else {
		string CHANNEL_STR("channel");
		ReadLock channelsLock( Channels );

		if (cDevice::CurrentChannel()) {
			const int SKIP_GAP = 1;
			cChannel* Channel = Channels.GetByNumber(cDevice::CurrentChannel());

			cChannel* tmp = Channels.GetByNumber(Channels.GetPrevNormal(cDevice::CurrentChannel()), -SKIP_GAP);
			if (tmp)
				prev_chan = tmp->GetChannelID();
			tmp = Channels.GetByNumber(Channels.GetNextNormal(cDevice::CurrentChannel()), SKIP_GAP);
			if (tmp)
				next_chan = tmp->GetChannelID();

			const string chanName(Channel->Name());
			cSchedulesLock schedulesLock;
			const cSchedules* Schedules = cSchedules::Schedules(schedulesLock);
			const cSchedule *Schedule = Schedules->GetSchedule(Channel);

			if (Schedule) {
				const cEvent *Event = Schedule->GetPresentEvent();
				if (Event) {
					epgEvent = EpgEvents::CreateEpgInfo(Channel,
														Event,
														CHANNEL_STR.c_str());
				}
				else {
					const string noInfo(tr("no epg info for current event!"));
					epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
														chanName,
														noInfo);
				}
			}
			else {
				const string noInfo(tr("no epg info for current channel!"));
				epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
													Channel->Name(),
													noInfo);
			}
		}
		else {
			const string chanName(tr("no current channel!"));
			epgEvent = EpgEvents::CreateEpgInfo(CHANNEL_STR,
												chanName,
												chanName);
		}
	}
	if (!epgEvent) {
		const string ERROR_STR("error");
		const string noInfo(tr("error retrieving status info!"));
		const string chanName(tr("no current channel!"));
		epgEvent = EpgEvents::CreateEpgInfo(ERROR_STR,
											chanName,
											noInfo);
	}
	else {
		if (prev_chan.Valid() && next_chan.Valid())
		{

  // <& xmlresponse.ibox ...
  { 
#line 120 "ibox.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "caption", tnt::toString((epgEvent->Caption()), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "currentTime", tnt::toString((epgEvent->CurrentTime(tr("%I:%M:%S %p"))), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "duration", tnt::toString((epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "elapsed", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "infoMsg", tnt::toString((infoMsg), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "infoUrl", tnt::toString((infoUrl), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "next_chan", tnt::toString((next_chan), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "prev_chan", tnt::toString((prev_chan), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "type", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    _tnt_cq0.add( "update", tnt::toString((update_status), reply.out().getloc() ) );
#line 120 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n
#line 121 "ibox.ecpp"

		}
		else if (prev_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 125 "ibox.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "caption", tnt::toString((epgEvent->Caption()), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "currentTime", tnt::toString((epgEvent->CurrentTime(tr("%I:%M:%S %p"))), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "duration", tnt::toString((epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "elapsed", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "infoMsg", tnt::toString((infoMsg), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "infoUrl", tnt::toString((infoUrl), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "prev_chan", tnt::toString((prev_chan), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "type", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    _tnt_cq1.add( "update", tnt::toString((update_status), reply.out().getloc() ) );
#line 125 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[1]; // \n
#line 126 "ibox.ecpp"

		}
		else if (next_chan.Valid()) {

  // <& xmlresponse.ibox ...
  { 
#line 130 "ibox.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "caption", tnt::toString((epgEvent->Caption()), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "currentTime", tnt::toString((epgEvent->CurrentTime(tr("%I:%M:%S %p"))), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "duration", tnt::toString((epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "elapsed", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "infoMsg", tnt::toString((infoMsg), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "infoUrl", tnt::toString((infoUrl), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "next_chan", tnt::toString((next_chan), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "type", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    _tnt_cq2.add( "update", tnt::toString((update_status), reply.out().getloc() ) );
#line 130 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[2]; // \n
#line 131 "ibox.ecpp"

		}
		else {

  // <& xmlresponse.ibox ...
  { 
#line 135 "ibox.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "caption", tnt::toString((epgEvent->Caption()), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "currentTime", tnt::toString((epgEvent->CurrentTime(tr("%I:%M:%S %p"))), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "duration", tnt::toString((epgEvent->StartTime(tr("%I:%M %p")) + string(" - ") + epgEvent->EndTime(tr("%I:%M %p"))), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "elapsed", tnt::toString((epgEvent->Elapsed()), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "infoMsg", tnt::toString((infoMsg), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "infoUrl", tnt::toString((infoUrl), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "title", tnt::toString((epgEvent->Title()), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "type", tnt::toString((epgEvent->Id()), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    _tnt_cq3.add( "update", tnt::toString((update_status), reply.out().getloc() ) );
#line 135 "ibox.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ibox"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[3]; // \n
#line 136 "ibox.ecpp"

		}
	}

  reply.out() << data[4]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
