////////////////////////////////////////////////////////////////////////
// keypress.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.keypress")

// <%pre>
#line 1 "keypress.ecpp"

#include <vdr/remote.h>
#include "setup.h"

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("keypress");

static const char* rawData = "\000\000\000\024\000\000\000)\000\000\000d\000\000\000\202\000\000\000\231<\?xml version="
  "\"1.0\"\?>\n<service>\n<request name=\"keypress\">\n<param name=\"keycode\"></param>\n</request>\n<response></respons"
  "e>\n</service>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("keypress " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int keycode = qparam.has("keycode") ? tnt::stringToWithDefault<int>(qparam.param("keycode"), ( kNone), reply.out().getloc()) : ( kNone);
  // </%args>

#line 12 "keypress.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 14 "keypress.ecpp"

	if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	reply.setContentType("application/xml");

  reply.out() << data[0]; // <\?xml version="1.0"\?>
  reply.out() << data[1]; // \n<service>\n<request name="keypress">\n<param name="keycode">
#line 21 "keypress.ecpp"
  reply.sout() << ( keycode );
  reply.out() << data[2]; // </param>\n</request>\n<response>
#line 23 "keypress.ecpp"
  reply.sout() << ( cRemote::Put( (eKeys)keycode ) ? "1" : "0" );
  reply.out() << data[3]; // </response>\n</service>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
