////////////////////////////////////////////////////////////////////////
// menu.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.menu")

// <%pre>
#line 1 "menu.ecpp"

#include <string>
#include <vdr/plugin.h>
#include <vdr/config.h>

#include "livefeatures.h"
#include "setup.h"
#include "i18n.h"
#include "timerconflict.h"

using namespace std;
using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class component_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        component_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    setactive_type setactive;
    component_type component;
};

static tnt::ComponentFactoryImpl<_component_> Factory("menu");

static const char* rawData = "\000\000\000\314\000\000\001\003\000\000\001\004\000\000\001$\000\000\001%\000\000\001J"
  "\000\000\001K\000\000\001i\000\000\001j\000\000\001o\000\000\001\213\000\000\001\214\000\000\001\260\000\000\001\261"
  "\000\000\001\266\000\000\001\323\000\000\001\324\000\000\001\362\000\000\001\363\000\000\002\020\000\000\002\021\000"
  "\000\002\026\000\000\002\027\000\000\002H\000\000\002M\000\000\002S\000\000\002}\000\000\002\257\000\000\002\311\000"
  "\000\002\352\000\000\002\354\000\000\002\361\000\000\003\025\000\000\003\202\000\000\003\216\000\000\003\251\000\000"
  "\003\360\000\000\003\364\000\000\003\370\000\000\003\374\000\000\003\375\000\000\004\000\000\000\004\004\000\000\004"
  "\005\000\000\004\010\000\000\004\014\000\000\004\020\000\000\004,\000\000\004-\000\000\004;\000\000\004<<div class=\""
  "menu\">\n\t  <a href=\"whats_on.html\?type=now\" ></a>\n\t| <a href=\"schedule.html\" ></a>\n\t| <a href=\"multisched"
  "ule.html\" ></a>\n\t| <a href=\"timers.html\" ></a>\n\t| <a href=\"searchepg.html\" ></a>\n\t| <a href=\"searchtimers"
  ".html\" ></a>\n\t| <a href=\"recordings.html\" ></a>\n\t| <a href=\"remote.html\" ></a>\n\t| <a href=\"setup.html\" >"
  "</a>\n\n\t| <a id=\"login\" href=\"login.html\?action=logout\"></a>\n\t| <a >\?</a>\n</div>\n<div id=\"messagebar\" c"
  "lass=\"\">\n  <div> <!-- outer -->\n\t<div><!-- inner -->\n\t  :\n\t  <span id=\"mbmessage\"></span>\n\t  <a id=\"mbr"
  "eact\" href=\"\"></a>\n      <span id=\"mbdelimiter\" class=\"\">|</span>\n\t  <span id=\"mbdismiss\"><a href=\"\" on"
  "click=\"$('messagebar').addClass('notpresent'); return false\"></a></span>\n    </div>\n  </div>\n</div>\n<div id=\"p"
  "agemenu\">\n  <div> <!-- outer -->\n    <div> <!-- inner -->\n\t  \n\t  \n\t  \n\t  \n\t  \n\t  \n\t  \n\t  \n\t  \n "
  "   </div>\n  </div>\n</div>\n\nclass=\"active\"\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    setactive(*this, "setactive"),
    component(*this, "component")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("menu " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string active = qparam.param("active");
std::string component = qparam.param("component");
  // </%args>

#line 20 "menu.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 21 "menu.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
#line 24 "menu.ecpp"
  typedef std::string set_active_type;
  TNT_REQUEST_PAGE_VAR(set_active_type, set_active, "std::string set_active", ());   // <%request> std::string set_active
#line 25 "menu.ecpp"
  typedef std::string set_component_type;
  TNT_REQUEST_PAGE_VAR(set_component_type, set_component, "std::string set_component", ());   // <%request> std::string set_component
  // <%cpp>
#line 27 "menu.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

set_active = active;
if (!component.empty()) {
	set_component = component;
}


  reply.out() << data[0]; // <div class="menu">\n\t  <a href="whats_on.html\?type=now" 
  // <& menu.setactive ...
  { 
#line 37 "menu.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 37 "menu.ecpp"
    _tnt_cq0.add( "current", tnt::toString(("whats_on"), reply.out().getloc() ) );
#line 37 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // >
#line 37 "menu.ecpp"
  reply.sout() << ( tr("What's on?") );
  reply.out() << data[2]; // </a>\n\t| <a href="schedule.html" 
  // <& menu.setactive ...
  { 
#line 38 "menu.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 38 "menu.ecpp"
    _tnt_cq1.add( "current", tnt::toString(("schedule"), reply.out().getloc() ) );
#line 38 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // >
#line 38 "menu.ecpp"
  reply.sout() << ( trVDR("Schedule") );
  reply.out() << data[4]; // </a>\n\t| <a href="multischedule.html" 
  // <& menu.setactive ...
  { 
#line 39 "menu.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 39 "menu.ecpp"
    _tnt_cq2.add( "current", tnt::toString(("multischedule"), reply.out().getloc() ) );
#line 39 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[5]; // >
#line 39 "menu.ecpp"
  reply.sout() << ( tr("MultiSchedule") );
  reply.out() << data[6]; // </a>\n\t| <a href="timers.html" 
  // <& menu.setactive ...
  { 
#line 40 "menu.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 40 "menu.ecpp"
    _tnt_cq3.add( "current", tnt::toString(("timers"), reply.out().getloc() ) );
#line 40 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[7]; // >
#line 40 "menu.ecpp"
  reply.sout() << ( trVDR("Timers") );
  reply.out() << data[8]; // </a>\n
#line 41 "menu.ecpp"

if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << data[9]; // \t| <a href="searchepg.html" 
  // <& menu.setactive ...
  { 
#line 44 "menu.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 44 "menu.ecpp"
    _tnt_cq4.add( "current", tnt::toString(("searchepg"), reply.out().getloc() ) );
#line 44 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[10]; // >
#line 44 "menu.ecpp"
  reply.sout() << ( tr("Search") );
  reply.out() << data[11]; // </a>\n\t| <a href="searchtimers.html" 
  // <& menu.setactive ...
  { 
#line 45 "menu.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 45 "menu.ecpp"
    _tnt_cq5.add( "current", tnt::toString(("searchtimers"), reply.out().getloc() ) );
#line 45 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[12]; // >
#line 45 "menu.ecpp"
  reply.sout() << ( tr("Searchtimers") );
  reply.out() << data[13]; // </a>\n
#line 46 "menu.ecpp"

}

  reply.out() << data[14]; // \t| <a href="recordings.html" 
  // <& menu.setactive ...
  { 
#line 49 "menu.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 49 "menu.ecpp"
    _tnt_cq6.add( "current", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 49 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[15]; // >
#line 49 "menu.ecpp"
  reply.sout() << ( tr("Recordings") );
  reply.out() << data[16]; // </a>\n\t| <a href="remote.html" 
  // <& menu.setactive ...
  { 
#line 50 "menu.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 50 "menu.ecpp"
    _tnt_cq7.add( "current", tnt::toString(("remote"), reply.out().getloc() ) );
#line 50 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[17]; // >
#line 50 "menu.ecpp"
  reply.sout() << ( tr("Remote Control") );
  reply.out() << data[18]; // </a>\n\t| <a href="setup.html" 
  // <& menu.setactive ...
  { 
#line 51 "menu.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 51 "menu.ecpp"
    _tnt_cq8.add( "current", tnt::toString(("setup"), reply.out().getloc() ) );
#line 51 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "setactive"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[19]; // >
#line 51 "menu.ecpp"
  reply.sout() << ( trVDR("Setup") );
  reply.out() << data[20]; // </a>\n
  reply.out() << data[21]; // \n
#line 55 "menu.ecpp"

if (LiveSetup().UseAuth()) {

  reply.out() << data[22]; // \t| <a id="login" href="login.html\?action=logout">
#line 58 "menu.ecpp"
  reply.sout() << ( tr("Logout") );
  reply.out() << data[23]; // </a>\n
#line 59 "menu.ecpp"

}

  reply.out() << data[24]; // \t| <a 
  // <& tooltip.display ...
  { 
#line 62 "menu.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 62 "menu.ecpp"
    _tnt_cq9.add( "domId", tnt::toString(("aboutBox"), reply.out().getloc() ) );
#line 62 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << data[25]; // >\?</a>\n</div>\n<div id="messagebar" class="
#line 64 "menu.ecpp"
  if ( !timerNotifier.ShouldNotify() )
    reply.sout() <<  "notpresent" ;
  reply.out() << data[26]; // ">\n  <div> <!-- outer -->\n\t<div><!-- inner -->\n\t  
#line 67 "menu.ecpp"
  reply.sout() << ( tr("Your attention is required") );
  reply.out() << data[27]; // :\n\t  <span id="mbmessage">
#line 68 "menu.ecpp"
  reply.sout() << ( timerNotifier.Message() );
  reply.out() << data[28]; // </span>\n\t  <a id="mbreact" href="
#line 69 "menu.ecpp"
  reply.sout() << ( timerNotifier.Url() );
  reply.out() << data[29]; // ">
#line 69 "menu.ecpp"
  reply.sout() << ( tr("React") );
  reply.out() << data[30]; // </a>\n
#line 70 "menu.ecpp"

if (LiveSetup().GetUseAjax()) {

  reply.out() << data[31]; //       <span id="mbdelimiter" class="
#line 73 "menu.ecpp"
  if ( timerNotifier.Url().empty() )
    reply.sout() <<  "notpresent" ;
  reply.out() << data[32]; // ">|</span>\n\t  <span id="mbdismiss"><a href="" onclick="$('messagebar').addClass('notpresent'); return false">
#line 74 "menu.ecpp"
  reply.sout() << ( tr("Dismiss") );
  reply.out() << data[33]; // </a></span>\n
#line 75 "menu.ecpp"

}

  reply.out() << data[34]; //     </div>\n  </div>\n</div>\n
#line 81 "menu.ecpp"

if (!component.empty()) {

  reply.out() << data[35]; // <div id="pagemenu">\n  <div> <!-- outer -->\n    <div> <!-- inner -->\n\t  
  // <& menu.component ...
  { 
#line 87 "menu.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 87 "menu.ecpp"
    _tnt_cq10.add( "current", tnt::toString(("whats_on"), reply.out().getloc() ) );
#line 87 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << data[36]; // \n\t  
  // <& menu.component ...
  { 
#line 88 "menu.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 88 "menu.ecpp"
    _tnt_cq11.add( "current", tnt::toString(("schedule"), reply.out().getloc() ) );
#line 88 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << data[37]; // \n\t  
  // <& menu.component ...
  { 
#line 89 "menu.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 89 "menu.ecpp"
    _tnt_cq12.add( "current", tnt::toString(("multischedule"), reply.out().getloc() ) );
#line 89 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << data[38]; // \n\t  
  // <& menu.component ...
  { 
#line 90 "menu.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 90 "menu.ecpp"
    _tnt_cq13.add( "current", tnt::toString(("timers"), reply.out().getloc() ) );
#line 90 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << data[39]; // \n
#line 91 "menu.ecpp"

	if (LiveFeatures< features::epgsearch >().Recent()) {

  reply.out() << data[40]; // \t  
  // <& menu.component ...
  { 
#line 94 "menu.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 94 "menu.ecpp"
    _tnt_cq14.add( "current", tnt::toString(("search"), reply.out().getloc() ) );
#line 94 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << data[41]; // \n\t  
  // <& menu.component ...
  { 
#line 95 "menu.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 95 "menu.ecpp"
    _tnt_cq15.add( "current", tnt::toString(("searchtimers"), reply.out().getloc() ) );
#line 95 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << data[42]; // \n
#line 96 "menu.ecpp"

	}

  reply.out() << data[43]; // \t  
  // <& menu.component ...
  { 
#line 99 "menu.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 99 "menu.ecpp"
    _tnt_cq16.add( "current", tnt::toString(("recordings"), reply.out().getloc() ) );
#line 99 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << data[44]; // \n\t  
  // <& menu.component ...
  { 
#line 100 "menu.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 100 "menu.ecpp"
    _tnt_cq17.add( "current", tnt::toString(("remote"), reply.out().getloc() ) );
#line 100 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << data[45]; // \n\t  
  // <& menu.component ...
  { 
#line 101 "menu.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 101 "menu.ecpp"
    _tnt_cq18.add( "current", tnt::toString(("users"), reply.out().getloc() ) );
#line 101 "menu.ecpp"
    callComp(tnt::Subcompident(std::string(), "menu", "component"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << data[46]; // \n    </div>\n  </div>\n</div>\n
#line 105 "menu.ecpp"

}

  reply.out() << data[47]; // \n
  reply.out() << data[49]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("menu::setactive " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string current = qparam.param("current");
  // </%args>

#line 24 "menu.ecpp"
  typedef std::string set_active_type;
  TNT_REQUEST_PAGE_VAR(set_active_type, set_active, "std::string set_active", ());   // <%request> std::string set_active
#line 25 "menu.ecpp"
  typedef std::string set_component_type;
  TNT_REQUEST_PAGE_VAR(set_component_type, set_component, "std::string set_component", ());   // <%request> std::string set_component
#line 20 "menu.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 21 "menu.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
  // <%cpp>
#line 113 "menu.ecpp"
 if (current == set_active) { 
  reply.out() << data[48]; // class="active"
#line 113 "menu.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::component_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("menu::component " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string current = qparam.param("current");
  // </%args>

#line 24 "menu.ecpp"
  typedef std::string set_active_type;
  TNT_REQUEST_PAGE_VAR(set_active_type, set_active, "std::string set_active", ());   // <%request> std::string set_active
#line 25 "menu.ecpp"
  typedef std::string set_component_type;
  TNT_REQUEST_PAGE_VAR(set_component_type, set_component, "std::string set_component", ());   // <%request> std::string set_component
#line 20 "menu.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 21 "menu.ecpp"
  typedef TimerConflictNotifier timerNotifier_type;
  TNT_SESSION_GLOBAL_VAR(timerNotifier_type, timerNotifier, "TimerConflictNotifier timerNotifier", ());   // <%session> TimerConflictNotifier timerNotifier
  // <%cpp>
#line 120 "menu.ecpp"
 if ((current == set_active) && (!set_component.empty())) { 
  // <& (set_component) ...
  { 
#line 120 "menu.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 120 "menu.ecpp"
    callComp((set_component), request, reply, _tnt_cq19);
    // &>
  }
#line 120 "menu.ecpp"
 } 
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
