////////////////////////////////////////////////////////////////////////
// remote.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.remote")

// <%pre>
#line 1 "remote.ecpp"

#include <locale>
#include <vdr/i18n.h>
#include <vdr/keys.h>
#include <vdr/device.h>
#include "grab.h"
#include "setup.h"
#include "tools.h"
#include "users.h"

using namespace std;
using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class remote_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        remote_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    remote_actions_type remote_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("remote");

static const char* rawData = "\000\000\000\300\000\000\000\301\000\000\000\345\000\000\000\360\000\000\000\363\000\000"
  "\005f\000\000\005\242\000\000\005\335\000\000\005\340\000\000\006\024\000\000\006 \000\000\006X\000\000\006y\000\000"
  "\007/\000\000\007\235\000\000\010\013\000\000\010{\000\000\010\351\000\000\tW\000\000\t\307\000\000\n8\000\000\n\250"
  "\000\000\013\032\000\000\013\212\000\000\013\373\000\000\014l\000\000\014\334\000\000\015L\000\000\015\274\000\000"
  "\016/\000\000\016\305\000\000\017j\000\000\017\376\000\000\020\224\000\000\021E\000\000\022\003\000\000\022\267\000"
  "\000\023b\000\000\023\321\000\000\024C\000\000\024\267\000\000\025-\000\000\025\242\000\000\025\362\000\000\025\363"
  "\000\000\025\364\000\000\026o\000\000\026p\n\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<scri"
  "pt type=\"text/javascript\"><!--\n\t\tvar newImg = new Image();\n\t\tvar imgsrc = \"\";\n\t\tvar interval = -1;\n\n\t"
  "\tfunction StreamLoad()\n\t\t{\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive"
  ".src=newImg.src;\n\t\t\tnewImg.src=imgsrc+\"\?\"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\timgsrc = doc"
  "ument.images.vdrlive.src;\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tnewImg.src=imgsrc+\"\?\"+uni"
  "q;\n\t\t\tinterval = window.setInterval(\"StreamLoad()\", 1000);\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t"
  "\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.cle"
  "arInterval(interval);\n\t\t\tinterval = window.setInterval(\"StreamLoad()\", timeout);\n\t\t}\n\n\t\tfunction KeyPres"
  "s(keycode)\n\t\t{\n\t\t\tLiveSimpleAjaxRequest('keypress.xml', 'keycode', keycode);\n\t\t}\n\n\t\tfunction FillInterv"
  "als()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar items = new Array(1000, "
  "2000, 5000);\n\t\t\telement.options.length = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\teleme"
  "nt.options[i].value = items[i];\n\t\t\t\telement.options[i].text = (items[i] / 1000) + \" s\";\n\t\t\t\tif (items[i] "
  "== )\n\t\t\t\t\telement.selectedIndex = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"StreamIni"
  "t(); FillIntervals();\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"screenshot\">\n\n\t\t\t\t\tbloek"
  "\n\n\t\t\t\t\t<img src=\"screenshot.jpg\" name=\"vdrlive\" /><br />\n\n\t\t\t</div>\n\t\t\t<div>\n\t\t\t<img src=\"\""
  " width=\"162\" height=\"378\" border=\"0\" usemap=\"#remote\" alt=\"\" />\n\t\t\t     <map name=\"remote\">\n\t\t\t  "
  "   \t  <area href=\"#\" shape=\"circle\" coords=\"37,36,10\" alt=\"Power\" onclick=\"KeyPress()\" nohref=\"nohref\" a"
  "lt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"27,60,59,75\" alt=\"1\" onclick=\"KeyPress()\" nohref="
  "\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"64,59,98,75\" alt=\"2\" onclick=\"KeyPress"
  "()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"103,59,137,75\" alt=\"3\" oncl"
  "ick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"25,82,60,98\" al"
  "t=\"4\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"65,8"
  "2,98,99\" alt=\"5\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" c"
  "oords=\"103,83,137,99\" alt=\"6\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" sh"
  "ape=\"rect\" coords=\"26,106,60,121\" alt=\"7\"  onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <are"
  "a href=\"#\" shape=\"rect\" coords=\"65,105,97,121\" alt=\"8\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n"
  "\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"104,106,137,122\" alt=\"9\" onclick=\"KeyPress()\" nohref=\"nohref"
  "\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"66,128,98,144\" alt=\"0\" onclick=\"KeyPress()\" n"
  "ohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,157,13\" alt=\"Vol+\" onclick="
  "\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"37,190,13\" alt=\""
  "Vol-\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle\" coords=\"125"
  ",157,13\" alt=\"P+\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"circle"
  "\" coords=\"125,190,13\" alt=\"P-\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" "
  "shape=\"circle\" coords=\"81,174,8\" alt=\"Mute\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <ar"
  "ea href=\"#\" shape=\"circle\" coords=\"81,202,11\" alt=\"Record\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" "
  "/>\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"39,215,29,227,30,235,39,236,51,222,49,215,43,213\" alt=\"Menu"
  "\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"119,213,1"
  "27,219,135,230,132,235,127,236,119,231,114,223,113,215\" alt=\"Exit\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\""
  "\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"33,289,31,298,43,310,51,308,54,300,41,287\" alt=\"Subtitles"
  "\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"131,289,1"
  "33,298,122,310,112,308,110,300,122,287\" alt=\"Audio\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t"
  "  <area href=\"#\" shape=\"poly\" coords=\"58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,"
  "232\" alt=\"Up\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coor"
  "ds=\"111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245\" alt=\"Right\" onclick="
  "\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"66,281,75,285,86,285"
  ",95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289\" alt=\"Down\" onclick=\"KeyPress()\" nohref=\"nohref\" al"
  "t=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"poly\" coords=\"51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264"
  ",43,252,49,240\" alt=\"Left\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape="
  "\"circle\" coords=\"81,261,17\" alt=\"Ok\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href"
  "=\"#\" shape=\"rect\" coords=\"25,324,52,339\" alt=\"Red\" onclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t"
  "\t\t  <area href=\"#\" shape=\"rect\" coords=\"53,324,81,339\" alt=\"Green\" onclick=\"KeyPress()\" nohref=\"nohref\""
  " alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"83,324,109,339\" alt=\"Yellow\" onclick=\"KeyPress()"
  "\" nohref=\"nohref\" alt=\"\" />\n\t\t\t\t  <area href=\"#\" shape=\"rect\" coords=\"110,324,137,339\" alt=\"Blue\" o"
  "nclick=\"KeyPress()\" nohref=\"nohref\" alt=\"\" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>"
  "\n\n\n: <select name=\"interval\" onchange=\"ChangeInterval()\"></select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&n"
  "bsp;&nbsp;&nbsp;\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    remote_actions(*this, "remote_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
int channel = qparam.has("channel") ? tnt::stringToWithDefault<int>(qparam.param("channel"), ( -1), reply.out().getloc()) : ( -1);
  // </%args>

#line 19 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 22 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 25 "remote.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

  reply.out() << data[0]; // \n
#line 28 "remote.ecpp"

	if (!cUser::CurrentUserHasRightTo(UR_USEREMOTE))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	pageTitle = tr("Remote Control");

	ReadLock channelsLock( Channels );
	if ( !channelsLock )
		throw HtmlError( tr("Couldn't aquire access to channels, please try again later.") );

	// cChannel* Channel; (see %request above)
	if ( channel > 0 ) {
		Channel = Channels.GetByNumber( channel );
	}
	else {
		if (cDevice::CurrentChannel()) {
			Channel = Channels.GetByNumber(cDevice::CurrentChannel());
		}
		else {
			Channel = Channels.Get( Channels.GetNextNormal( -1 ) );
		}
	}
	if ( Channel == 0 )
		throw HtmlError( tr("Couldn't find channel or no channels available. Maybe you mistyped your request?") );


  // <& pageelems.doc_type ...
  { 
#line 54 "remote.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 54 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 57 "remote.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[2]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 58 "remote.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 58 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[3]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 59 "remote.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 59 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[4]; // \n\t\t<script type="text/javascript"><!--\n\t\tvar newImg = new Image();\n\t\tvar imgsrc = "";\n\t\tvar interval = -1;\n\n\t\tfunction StreamLoad()\n\t\t{\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tdocument.images.vdrlive.src=newImg.src;\n\t\t\tnewImg.src=imgsrc+"\?"+uniq;\n\t\t}\n\n\t\tfunction StreamInit()\n\t\t{\n\t\t\timgsrc = document.images.vdrlive.src;\n\t\t\tuniq = new Date();\n\t\t\tuniq = uniq.getTime();\n\t\t\tnewImg.src=imgsrc+"\?"+uniq;\n\t\t\tinterval = window.setInterval("StreamLoad()", 1000);\n\t\t}\n\n\t\tfunction ChangeInterval()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar timeout = element.value;\n\t\t\twindow.clearInterval(interval);\n\t\t\tinterval = window.setInterval("StreamLoad()", timeout);\n\t\t}\n\n\t\tfunction KeyPress(keycode)\n\t\t{\n\t\t\tLiveSimpleAjaxRequest('keypress.xml', 'keycode', keycode);\n\t\t}\n\n\t\tfunction FillIntervals()\n\t\t{\n\t\t\tvar element = document.getElementsByName('interval').item(0);\n\t\t\tvar items = new Array(1000, 2000, 5000);\n\t\t\telement.options.length = items.length;\n\t\t\tfor (i = 0; i < items.length; ++i) {\n\t\t\t\telement.options[i].value = items[i];\n\t\t\t\telement.options[i].text = (items[i] / 1000) + " s";\n\t\t\t\tif (items[i] == 
#line 103 "remote.ecpp"
  reply.sout() << ( ConvertToString( LiveSetup().GetScreenshotInterval(), locale("C") ) );
  reply.out() << data[5]; // )\n\t\t\t\t\telement.selectedIndex = i;\n\t\t\t}\n\t\t}\n\t\t//--></script>\n
#line 108 "remote.ecpp"
 reply.sout().imbue(locale());

  reply.out() << data[6]; // \t</head>\n\t<body onload="StreamInit(); FillIntervals();">\n\t\t
  // <& pageelems.logo ...
  { 
#line 111 "remote.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 111 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[7]; // \n\t\t
  // <& menu ...
  { 
#line 112 "remote.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 112 "remote.ecpp"
    _tnt_cq4.add( "active", tnt::toString("remote", reply.out().getloc() ) );
#line 112 "remote.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("remote.remote_actions"), reply.out().getloc() ) );
#line 112 "remote.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[8]; // \n\t\t<div class="inhalt">\n\t\t\t<div class="screenshot">\n
#line 115 "remote.ecpp"
				if (!LiveGrabImageManager().CanGrab()) {	
  reply.out() << data[9]; // \n\t\t\t\t\tbloek\n
#line 117 "remote.ecpp"
				} else {									
  reply.out() << data[10]; // \n\t\t\t\t\t<img src="screenshot.jpg" name="vdrlive" /><br />\n
#line 119 "remote.ecpp"
				}											
  reply.out() << data[11]; // \n\t\t\t</div>\n\t\t\t<div>\n\t\t\t<img src="
#line 122 "remote.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "remotecontrol.jpg") );
  reply.out() << data[12]; // " width="162" height="378" border="0" usemap="#remote" alt="" />\n\t\t\t     <map name="remote">\n\t\t\t     \t  <area href="#" shape="circle" coords="37,36,10" alt="Power" onclick="KeyPress(
#line 124 "remote.ecpp"
  reply.sout() << ( kPower );
  reply.out() << data[13]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="27,60,59,75" alt="1" onclick="KeyPress(
#line 125 "remote.ecpp"
  reply.sout() << ( k1 );
  reply.out() << data[14]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="64,59,98,75" alt="2" onclick="KeyPress(
#line 126 "remote.ecpp"
  reply.sout() << ( k2 );
  reply.out() << data[15]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,59,137,75" alt="3" onclick="KeyPress(
#line 127 "remote.ecpp"
  reply.sout() << ( k3 );
  reply.out() << data[16]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,82,60,98" alt="4" onclick="KeyPress(
#line 128 "remote.ecpp"
  reply.sout() << ( k4 );
  reply.out() << data[17]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,82,98,99" alt="5" onclick="KeyPress(
#line 129 "remote.ecpp"
  reply.sout() << ( k5 );
  reply.out() << data[18]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="103,83,137,99" alt="6" onclick="KeyPress(
#line 130 "remote.ecpp"
  reply.sout() << ( k6 );
  reply.out() << data[19]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="26,106,60,121" alt="7"  onclick="KeyPress(
#line 131 "remote.ecpp"
  reply.sout() << ( k7 );
  reply.out() << data[20]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="65,105,97,121" alt="8" onclick="KeyPress(
#line 132 "remote.ecpp"
  reply.sout() << ( k8 );
  reply.out() << data[21]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="104,106,137,122" alt="9" onclick="KeyPress(
#line 133 "remote.ecpp"
  reply.sout() << ( k9 );
  reply.out() << data[22]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="66,128,98,144" alt="0" onclick="KeyPress(
#line 134 "remote.ecpp"
  reply.sout() << ( k0 );
  reply.out() << data[23]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,157,13" alt="Vol+" onclick="KeyPress(
#line 135 "remote.ecpp"
  reply.sout() << ( kVolUp );
  reply.out() << data[24]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="37,190,13" alt="Vol-" onclick="KeyPress(
#line 136 "remote.ecpp"
  reply.sout() << ( kVolDn );
  reply.out() << data[25]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,157,13" alt="P+" onclick="KeyPress(
#line 137 "remote.ecpp"
  reply.sout() << ( kChanUp );
  reply.out() << data[26]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="125,190,13" alt="P-" onclick="KeyPress(
#line 138 "remote.ecpp"
  reply.sout() << ( kChanDn );
  reply.out() << data[27]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,174,8" alt="Mute" onclick="KeyPress(
#line 139 "remote.ecpp"
  reply.sout() << ( kMute );
  reply.out() << data[28]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,202,11" alt="Record" onclick="KeyPress(
#line 140 "remote.ecpp"
  reply.sout() << ( kRecord );
  reply.out() << data[29]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="39,215,29,227,30,235,39,236,51,222,49,215,43,213" alt="Menu" onclick="KeyPress(
#line 141 "remote.ecpp"
  reply.sout() << ( kMenu );
  reply.out() << data[30]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="119,213,127,219,135,230,132,235,127,236,119,231,114,223,113,215" alt="Exit" onclick="KeyPress(
#line 142 "remote.ecpp"
  reply.sout() << ( kBack );
  reply.out() << data[31]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="33,289,31,298,43,310,51,308,54,300,41,287" alt="Subtitles" onclick="KeyPress(
#line 143 "remote.ecpp"
  reply.sout() << ( kSubtitles );
  reply.out() << data[32]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="131,289,133,298,122,310,112,308,110,300,122,287" alt="Audio" onclick="KeyPress(
#line 144 "remote.ecpp"
  reply.sout() << ( kAudio );
  reply.out() << data[33]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="58,230,70,223,82,223,91,223,105,231,96,240,87,237,78,236,69,240,66,241,58,232" alt="Up" onclick="KeyPress(
#line 145 "remote.ecpp"
  reply.sout() << ( kUp );
  reply.out() << data[34]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="111,237,119,249,121,259,119,275,113,285,109,284,101,276,104,270,107,260,106,253,101,245" alt="Right" onclick="KeyPress(
#line 146 "remote.ecpp"
  reply.sout() << ( kRight );
  reply.out() << data[35]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="66,281,75,285,86,285,95,281,106,291,100,295,87,300,73,300,58,291,57,289,58,289" alt="Down" onclick="KeyPress(
#line 147 "remote.ecpp"
  reply.sout() << ( kDown );
  reply.out() << data[36]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="poly" coords="51,236,61,245,56,256,57,266,61,277,52,285,47,278,42,264,43,252,49,240" alt="Left" onclick="KeyPress(
#line 148 "remote.ecpp"
  reply.sout() << ( kLeft );
  reply.out() << data[37]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="circle" coords="81,261,17" alt="Ok" onclick="KeyPress(
#line 149 "remote.ecpp"
  reply.sout() << ( kOk );
  reply.out() << data[38]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="25,324,52,339" alt="Red" onclick="KeyPress(
#line 150 "remote.ecpp"
  reply.sout() << ( kRed );
  reply.out() << data[39]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="53,324,81,339" alt="Green" onclick="KeyPress(
#line 151 "remote.ecpp"
  reply.sout() << ( kGreen );
  reply.out() << data[40]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="83,324,109,339" alt="Yellow" onclick="KeyPress(
#line 152 "remote.ecpp"
  reply.sout() << ( kYellow );
  reply.out() << data[41]; // )" nohref="nohref" alt="" />\n\t\t\t\t  <area href="#" shape="rect" coords="110,324,137,339" alt="Blue" onclick="KeyPress(
#line 153 "remote.ecpp"
  reply.sout() << ( kBlue );
  reply.out() << data[42]; // )" nohref="nohref" alt="" />\n\t\t\t     </map>\n\t\t\t</div>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[43]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[44]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::remote_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("remote::remote_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 22 "remote.ecpp"
  typedef cChannel* Channel_type;
  TNT_REQUEST_PAGE_VAR(Channel_type, Channel, "cChannel* Channel", ());   // <%request> cChannel* Channel
#line 19 "remote.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
#line 162 "remote.ecpp"
  reply.sout() << ( tr("Snapshot interval") );
  reply.out() << data[45]; // : <select name="interval" onchange="ChangeInterval()"></select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
  // <& pageelems.vlc_stream_channel ...
  { 
#line 162 "remote.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 162 "remote.ecpp"
    _tnt_cq5.add( "channelId", tnt::toString((Channel->GetChannelID()), reply.out().getloc() ) );
#line 162 "remote.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "vlc_stream_channel"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[46]; // \n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
