////////////////////////////////////////////////////////////////////////
// screenshot.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.screenshot")

// <%pre>
#line 1 "screenshot.ecpp"

#include <vdr/config.h>
#include "setup.h"
#include "grab.h"

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("screenshot");

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("screenshot " << qparam.getUrl());


  // <%args>
int quality = qparam.has("quality") ? tnt::stringToWithDefault<int>(qparam.param("quality"), ( 80), reply.out().getloc()) : ( 80);
int width = qparam.has("width") ? tnt::stringToWithDefault<int>(qparam.param("width"), ( 569), reply.out().getloc()) : ( 569);
int height = qparam.has("height") ? tnt::stringToWithDefault<int>(qparam.param("height"), ( 320), reply.out().getloc()) : ( 320);
  // </%args>

#line 15 "screenshot.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
  // <%cpp>
#line 17 "screenshot.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");
	reply.setContentType("image/jpg");

	GrabImageInfo image = LiveGrabImageManager().GetImage();
	if ( image.second > 0 )
		reply.out().write( image.first.get(), image.second );

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
