////////////////////////////////////////////////////////////////////////
// users.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.users")

// <%pre>
#line 1 "users.ecpp"

#include <vdr/channels.h>
#include <vdr/i18n.h>
#include "users.h"
#include "setup.h"

using namespace vdrlive;
using namespace std;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even a empty line.
#include <tnt/savepoint.h>
#include "exception.h"

#line 2 "page_exit.eh"

#include "exception.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class user_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        user_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    user_actions_type user_actions;
};

static tnt::ComponentFactoryImpl<_component_> Factory("users");

static const char* rawData = "\000\000\000d\000\000\000\210\000\000\000\223\000\000\000\226\000\000\000\252\000\000\000"
  "\255\000\000\001S\000\000\001\315\000\000\002\013\000\000\002I\000\000\002c\000\000\002\201\000\000\002\242\000\000"
  "\002\256\000\000\002\267\000\000\002\356\000\000\003\013\000\000\003%\000\000\003.\000\000\003J\000\000\003p\000\000"
  "\003q\000\000\003r\000\000\003\213\000\000\003\220\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t<"
  "/head>\n\t<body>\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpaddin"
  "g=\"0\">\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"3\">\n\t\t\t\t\t\t<div class=\"boxheader\"><div><div><"
  "/div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"description\">\n\t\t\t\t\t<td class=\"action l"
  "eftcol\"><div class=\"leftcol\"></div></td>\n\t\t\t\t\t<td class=\"rightcol\" colspan=\"8\"/>\n\t\t\t\t</tr>\n\t\t\t"
  "\t\t<tr class=\"description\">\n\t\t\t\t\t\t<td class=\"action leftcol \"><div class=\"withmargin\"></div></td>\t\n\t"
  "\t\t\t\t\t<td class=\"\"><a href=\"edit_user.html\?userid=\"><img src=\"\" alt=\"\" ></img></a></td>\t\t\t\t\t\n\t\t"
  "\t\t\t\t<td class=\"action rightcol \"><a href=\"users.html\?userid=&action=delete\"><img src=\"\" alt=\"\" ></img></"
  "a></td>\n\t\t\t\t\t</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n<a href=\"edit_user.html\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    user_actions(*this, "user_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
string userid = tnt::stringTo<string>("userid", "string", qparam.param("userid"), reply.out().getloc());
string action = tnt::stringTo<string>("action", "string", qparam.param("action"), reply.out().getloc());
  // </%args>

#line 17 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 20 "users.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

#line 23 "users.ecpp"

	pageTitle = tr("Users");
	if ( !userid.empty() ) {
		if (action == "delete")
		{
			Users.Del(Users.GetByUserId( userid ));
			Users.Save();
		}
	}

  // <& pageelems.doc_type ...
  { 
#line 33 "users.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 33 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 36 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[1]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 37 "users.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 37 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << data[2]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 38 "users.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 38 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n\t</head>\n\t<body>\n\t\t
  // <& pageelems.logo ...
  { 
#line 41 "users.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 41 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n\t\t
  // <& menu ...
  { 
#line 42 "users.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 42 "users.ecpp"
    _tnt_cq4.add( "active", tnt::toString(("users"), reply.out().getloc() ) );
#line 42 "users.ecpp"
    _tnt_cq4.add( "component", tnt::toString(("users.user_actions"), reply.out().getloc() ) );
#line 42 "users.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n\t\t<div class="inhalt">\n\t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="3">\n\t\t\t\t\t\t<div class="boxheader"><div><div>
#line 47 "users.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << data[6]; // </div></div></div>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class="description">\n\t\t\t\t\t<td class="action leftcol"><div class="leftcol">
#line 51 "users.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << data[7]; // </div></td>\n\t\t\t\t\t<td class="rightcol" colspan="8"/>\n\t\t\t\t</tr>\n
#line 54 "users.ecpp"

				cUser* user = Users.First();
				while (user) 
    				{
					bool bottom = (Users.Next(user) == NULL);
				    if (user) 
				    {

  reply.out() << data[8]; // \t\t\t\t\t<tr class="description">\n\t\t\t\t\t\t<td class="action leftcol 
#line 63 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[9]; // "><div class="withmargin">
#line 63 "users.ecpp"
  reply.sout() << ( user->Name() );
  reply.out() << data[10]; // </div></td>\t\n\t\t\t\t\t\t<td class="
#line 64 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[11]; // "><a href="edit_user.html\?userid=
#line 64 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << data[12]; // "><img src="
#line 64 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << data[13]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 64 "users.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 64 "users.ecpp"
    _tnt_cq5.add( "text", tnt::toString((tr("Edit user")), reply.out().getloc() ) );
#line 64 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[14]; // ></img></a></td>\t\t\t\t\t\n\t\t\t\t\t\t<td class="action rightcol 
#line 65 "users.ecpp"
  if ( bottom )
    reply.sout() <<  "bottomrow" ;
  reply.out() << data[15]; // "><a href="users.html\?userid=
#line 65 "users.ecpp"
  reply.sout() << ( user->Id() );
  reply.out() << data[16]; // &action=delete"><img src="
#line 65 "users.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << data[17]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 65 "users.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 65 "users.ecpp"
    _tnt_cq6.add( "text", tnt::toString((tr("Delete user")), reply.out().getloc() ) );
#line 65 "users.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[18]; // ></img></a></td>\n\t\t\t\t\t</tr>\n
#line 67 "users.ecpp"

				    }
				    user = Users.Next(user);
				}

  reply.out() << data[19]; // \t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << data[20]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << data[21]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::user_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("users::user_actions " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 17 "users.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_GLOBAL_VAR(logged_in_type, logged_in, "bool logged_in", (false));   // <%session> bool logged_in(false)
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_GLOBAL_VAR(pageTitle_type, pageTitle, "std::string pageTitle", ());   // <%request> std::string pageTitle
  // <%cpp>
  reply.out() << data[22]; // <a href="edit_user.html">
#line 79 "users.ecpp"
  reply.sout() << ( tr("New user") );
  reply.out() << data[23]; // </a>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
