////////////////////////////////////////////////////////////////////////
// xmlresponse.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.xmlresponse")

// <%pre>
#line 1 "xmlresponse.ecpp"

#include <string>
#include "i18n.h"

using namespace std;
using namespace vdrlive;

string const XMLHEADER = "<?xml version=\"1.0\" encoding=\"" + LiveI18n().CharacterEncoding() + "\"?>";


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class ajax_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ibox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ibox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    ajax_type ajax;
    ibox_type ibox;
};

static tnt::ComponentFactoryImpl<_component_> Factory("xmlresponse");

static const char* rawData = "\000\000\000h\000\000\000i\000\000\000k\000\000\000\207\000\000\000\234\000\000\000\236"
  "\000\000\000\300\000\000\000\325\000\000\000\351\000\000\000\352\000\000\000\354\000\000\001%\000\000\001z\000\000"
  "\001\230\000\000\001\254\000\000\001\303\000\000\001\327\000\000\001\354\000\000\002\004\000\000\002\034\000\000\0025"
  "\000\000\002Y\000\000\002l\000\000\002\200\000\000\002\221\000\000\002\234\n\n\n\n<service>\n  <request name=\"\">\n "
  "    <param name=\"\"></param>\n  </request>\n  <response></response>\n  <error></error>\n</service>\n\n\n\n\n<service"
  ">\n  <request name=\"ibox\">\n\t<param name=\"update\"></param>\n  </request>\n  <response>1</response>\n  <error></e"
  "rror>\n  <values>\n\t<update></update>\n\t<epginfo>\n\t  <type></type>\n\t  <caption></caption>\n\t  <timenow></timen"
  "ow>\n\t  <name></name>\n\t  <duration></duration>\n\t  <elapsed></elapsed>\n\t  <nextchan></nextchan>\n\t  <prevchan>"
  "</prevchan>\n\t</epginfo>\n  </values>\n  <info>\n\t<message></message>\n    <url></url>\n  </info>\n</service>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    ajax(*this, "ajax"),
    ibox(*this, "ibox")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // \n
  reply.out() << data[1]; // \n\n
  reply.out() << data[8]; // \n
  reply.out() << data[9]; // \n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::ajax_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse::ajax " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
string name = tnt::stringTo<string>("name", "string", qparam.param("name"), reply.out().getloc());
string pname = tnt::stringTo<string>("pname", "string", qparam.param("pname"), reply.out().getloc());
string value = tnt::stringTo<string>("value", "string", qparam.param("value"), reply.out().getloc());
bool result = tnt::stringTo<bool>("result", "bool", qparam.param("result"), reply.out().getloc());
string error = tnt::stringTo<string>("error", "string", qparam.param("error"), reply.out().getloc());
  // </%args>

  // <%cpp>
#line 22 "xmlresponse.ecpp"
  reply.out() << ( XMLHEADER );
  reply.out() << data[2]; // \n<service>\n  <request name="
#line 24 "xmlresponse.ecpp"
  reply.sout() << ( name );
  reply.out() << data[3]; // ">\n     <param name="
#line 25 "xmlresponse.ecpp"
  reply.sout() << ( pname );
  reply.out() << data[4]; // ">
#line 25 "xmlresponse.ecpp"
  reply.sout() << ( value );
  reply.out() << data[5]; // </param>\n  </request>\n  <response>
#line 27 "xmlresponse.ecpp"
  reply.sout() << ( result );
  reply.out() << data[6]; // </response>\n  <error>
#line 28 "xmlresponse.ecpp"
  reply.sout() << ( error );
  reply.out() << data[7]; // </error>\n</service>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::ibox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("xmlresponse::ibox " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
int update = tnt::stringTo<int>("update", "int", qparam.param("update"), reply.out().getloc());
string type = tnt::stringTo<string>("type", "string", qparam.param("type"), reply.out().getloc());
string currentTime = tnt::stringTo<string>("currentTime", "string", qparam.param("currentTime"), reply.out().getloc());
string caption = tnt::stringTo<string>("caption", "string", qparam.param("caption"), reply.out().getloc());
string title = tnt::stringTo<string>("title", "string", qparam.param("title"), reply.out().getloc());
string duration = tnt::stringTo<string>("duration", "string", qparam.param("duration"), reply.out().getloc());
int elapsed = tnt::stringTo<int>("elapsed", "int", qparam.param("elapsed"), reply.out().getloc());
string prev_chan = tnt::stringTo<string>("prev_chan", "string", qparam.param("prev_chan"), reply.out().getloc());
string next_chan = tnt::stringTo<string>("next_chan", "string", qparam.param("next_chan"), reply.out().getloc());
string infoMsg = tnt::stringTo<string>("infoMsg", "string", qparam.param("infoMsg"), reply.out().getloc());
string infoUrl = tnt::stringTo<string>("infoUrl", "string", qparam.param("infoUrl"), reply.out().getloc());
  // </%args>

  // <%cpp>
#line 48 "xmlresponse.ecpp"
  reply.out() << ( XMLHEADER );
  reply.out() << data[10]; // \n<service>\n  <request name="ibox">\n\t<param name="update">
#line 51 "xmlresponse.ecpp"
  reply.sout() << ( update );
  reply.out() << data[11]; // </param>\n  </request>\n  <response>1</response>\n  <error></error>\n  <values>\n\t<update>
#line 56 "xmlresponse.ecpp"
  reply.sout() << ( update );
  reply.out() << data[12]; // </update>\n\t<epginfo>\n\t  <type>
#line 58 "xmlresponse.ecpp"
  reply.sout() << ( type );
  reply.out() << data[13]; // </type>\n\t  <caption>
#line 59 "xmlresponse.ecpp"
  reply.sout() << ( caption );
  reply.out() << data[14]; // </caption>\n\t  <timenow>
#line 60 "xmlresponse.ecpp"
  reply.sout() << ( currentTime );
  reply.out() << data[15]; // </timenow>\n\t  <name>
#line 61 "xmlresponse.ecpp"
  reply.sout() << ( title );
  reply.out() << data[16]; // </name>\n\t  <duration>
#line 62 "xmlresponse.ecpp"
  reply.sout() << ( duration );
  reply.out() << data[17]; // </duration>\n\t  <elapsed>
#line 63 "xmlresponse.ecpp"
  reply.sout() << ( elapsed );
  reply.out() << data[18]; // </elapsed>\n\t  <nextchan>
#line 64 "xmlresponse.ecpp"
  reply.sout() << ( next_chan );
  reply.out() << data[19]; // </nextchan>\n\t  <prevchan>
#line 65 "xmlresponse.ecpp"
  reply.sout() << ( prev_chan );
  reply.out() << data[20]; // </prevchan>\n\t</epginfo>\n  </values>\n
#line 68 "xmlresponse.ecpp"

if (!infoMsg.empty()) {

  reply.out() << data[21]; //   <info>\n\t<message>
#line 72 "xmlresponse.ecpp"
  reply.sout() << ( infoMsg );
  reply.out() << data[22]; // </message>\n    <url>
#line 73 "xmlresponse.ecpp"
  reply.sout() << ( infoUrl );
  reply.out() << data[23]; // </url>\n  </info>\n
#line 75 "xmlresponse.ecpp"

}

  reply.out() << data[24]; // </service>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
